
#property copyright " 2011 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define major   1
#define minor   0

extern string _tmp1_ = " --- Trade params ---";
extern int    AccDigits = 5;
extern bool   MarketExecution = false;
extern double Lot = 0.1;
extern int    StopLoss = 250;
extern int    TakeProfit = 100;
extern int    Slippage = 3;
extern int    Magic = 20110207;


extern string _tmp2a_ = " --- Stochastic1 ---";
extern int    Stoch1.Kperiod = 5;
extern int    Stoch1.Dperiod = 3;
extern int    Stoch1.slowing = 3;
extern int    Stoch1.method = MODE_SMA;
extern int    Stoch1.price_field = 0;
extern int    Stoch1.SignalBar = 1;
extern double Stoch1.OverboughtLevel = 70.0;
extern double Stoch1.OversoldLevel = 30.0;


extern string _tmp2b_ = " --- Stochastic2 ---";
extern bool   Stoch2.Use = true;
extern int    Stoch2.TimeFrame = PERIOD_H4;
extern int    Stoch2.Kperiod = 5;
extern int    Stoch2.Dperiod = 3;
extern int    Stoch2.slowing = 3;
extern int    Stoch2.method = MODE_SMA;
extern int    Stoch2.price_field = 0;
extern int    Stoch2.SignalBar = 1;
extern double Stoch2.OverboughtLevel = 70.0;
extern double Stoch2.OversoldLevel = 30.0;


extern string _tmp2c_ = " --- Stochastic3 ---";
extern bool   Stoch3.Use = true;
extern int    Stoch3.TimeFrame = PERIOD_D1;
extern int    Stoch3.Kperiod = 5;
extern int    Stoch3.Dperiod = 3;
extern int    Stoch3.slowing = 3;
extern int    Stoch3.method = MODE_SMA;
extern int    Stoch3.price_field = 0;
extern int    Stoch3.SignalBar = 1;
extern double Stoch3.OverboughtLevel = 70.0;
extern double Stoch3.OversoldLevel = 30.0;


extern string _tmp3_ = " --- Chart ---";
extern color clBuy = DodgerBlue;
extern color clSell = Red;
extern color clClose = Gold;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <stdlib.mqh>
#include <stderror.mqh>

int RepeatN = 5;

int BuyCnt, SellCnt;
int BuyStopCnt, SellStopCnt;
int BuyLimitCnt, SellLimitCnt;


void init() 
{
}

void deinit() 
{
}

void start() 
{
  double Stoch1.M1, Stoch1.M2;
  Stoch1.M1 = iStochastic(NULL, 0, Stoch1.Kperiod, Stoch1.Dperiod, Stoch1.slowing, Stoch1.method, Stoch1.price_field, MODE_MAIN, Stoch1.SignalBar);
  Stoch1.M2 = iStochastic(NULL, 0, Stoch1.Kperiod, Stoch1.Dperiod, Stoch1.slowing, Stoch1.method, Stoch1.price_field, MODE_MAIN, Stoch1.SignalBar+1);

  bool BuySig = (Stoch1.M1 > Stoch1.OversoldLevel && Stoch1.M2 <= Stoch1.OversoldLevel);
  bool SellSig = (Stoch1.M1 < Stoch1.OverboughtLevel && Stoch1.M2 >= Stoch1.OverboughtLevel);

  if (Stoch2.Use)
  {
    double Stoch2.M1, Stoch2.M2;
    Stoch2.M1 = iStochastic(NULL, Stoch2.TimeFrame, Stoch2.Kperiod, Stoch2.Dperiod, Stoch2.slowing, Stoch2.method, Stoch2.price_field, MODE_MAIN, Stoch2.SignalBar);
    Stoch2.M2 = iStochastic(NULL, Stoch2.TimeFrame, Stoch2.Kperiod, Stoch2.Dperiod, Stoch2.slowing, Stoch2.method, Stoch2.price_field, MODE_MAIN, Stoch2.SignalBar+1);

    BuySig = BuySig && (Stoch2.M1 <= Stoch2.OversoldLevel);
    SellSig = SellSig && (Stoch2.M1 >= Stoch2.OverboughtLevel);
  }

  if (Stoch3.Use)
  {
    double Stoch3.M1, Stoch3.M2;
    Stoch3.M1 = iStochastic(NULL, Stoch3.TimeFrame, Stoch3.Kperiod, Stoch3.Dperiod, Stoch3.slowing, Stoch3.method, Stoch3.price_field, MODE_MAIN, Stoch3.SignalBar);
    Stoch3.M2 = iStochastic(NULL, Stoch3.TimeFrame, Stoch3.Kperiod, Stoch3.Dperiod, Stoch3.slowing, Stoch3.method, Stoch3.price_field, MODE_MAIN, Stoch3.SignalBar+1);

    BuySig = BuySig && (Stoch3.M1 <= Stoch3.OversoldLevel);
    SellSig = SellSig && (Stoch3.M1 >= Stoch3.OverboughtLevel);
  }
    
  //-----
  
  if (BuySig)
  {
    if (CloseOrders(OP_SELL) > 0) return;
  }

  if (SellSig)
  {
    if (CloseOrders(OP_BUY) > 0) return;
  }

  //-----
  
  if (OrdersCountBar0(0) > 0) return;

  RecountOrders();
  
         
  double lot, price, sl, tp;
  int ticket;
  string comment;
  
  if (BuySig)
  {
    if (BuyCnt > 0) return;
    
    //-----
          
    if (MarketExecution)
    {
      for (int i=0; i<RepeatN; i++)
      {
        RefreshRates();
        price = Ask;
      
        lot = GetLots();
        comment = "";
        
        ticket = Buy(Symbol(), lot, price, 0, 0, Magic, comment);
        if (ticket > 0) break;
      }

      for (i=0; i<2*RepeatN; i++)
      {
        if (ticket <= 0) break;
        if (!OrderSelect(ticket, SELECT_BY_TICKET)) break;
  
        sl = If(StopLoss > 0, OrderOpenPrice() - StopLoss*Point*fpc(), 0);
        tp = If(TakeProfit > 0, OrderOpenPrice() + TakeProfit*Point*fpc(), 0);
  
        if (sl > 0 || tp > 0)
        {
          bool res = OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0);
          if (res) break;
        }
      }
    }

    else
    {      
      for (i=0; i<RepeatN; i++)
      {
        RefreshRates();
        price = Ask;

        sl = If(StopLoss > 0, price - StopLoss*Point*fpc(), 0);
        tp = If(TakeProfit > 0, price + TakeProfit*Point*fpc(), 0);
      
        lot = GetLots();
        comment = "";

        ticket = Buy(Symbol(), lot, price, sl, tp, Magic, comment);
        if (ticket > 0) break;
      }
    }
    
    return;
  }
  
  //-----
  
  if (SellSig)
  {
    if (SellCnt > 0) return;
    
    //-----

    if (MarketExecution)
    {
      for (i=0; i<RepeatN; i++)
      {
        RefreshRates();
        price = Bid;        
      
        lot = GetLots();
        comment = "";
        
        ticket = Sell(Symbol(), lot, price, 0, 0, Magic, comment);
        if (ticket > 0) break;
      }

      for (i=0; i<2*RepeatN; i++)
      {
        if (ticket <= 0) break;
        if (!OrderSelect(ticket, SELECT_BY_TICKET)) break;
  
        sl = If(StopLoss > 0, OrderOpenPrice() + StopLoss*Point*fpc(), 0);
        tp = If(TakeProfit > 0, OrderOpenPrice() - TakeProfit*Point*fpc(), 0);
  
        if (sl > 0 || tp > 0)
        {
          res = OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0);
          if (res) break;
        }
      }
    }

    else
    {
      for (i=0; i<RepeatN; i++)
      {  
        RefreshRates();
        price = Bid;
  
        sl = If(StopLoss > 0, price + StopLoss*Point*fpc(), 0);
        tp = If(TakeProfit > 0, price - TakeProfit*Point*fpc(), 0);

        lot = GetLots();
        comment = "";

        ticket = Sell(Symbol(), lot, price, sl, tp, Magic, comment);
        if (ticket > 0) break;
      }
    }
    
    return;
  } 
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double If(bool cond, double if_true, double if_false)
{
  if (cond) return (if_true);
  return (if_false);
}

int fpc()
{
  if (AccDigits == 5) return (10);
  if (AccDigits == 6) return (100);
  return (1); 
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double GetLots() 
{ 
  return (Lot);
}

void RecountOrders()
{
  BuyCnt = 0;
  SellCnt = 0;
  BuyStopCnt = 0;
  SellStopCnt = 0;
  BuyLimitCnt = 0;
  SellLimitCnt = 0;

  int cnt = OrdersTotal();
  for (int i=0; i < cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type = OrderType();
    if (type == OP_BUY) BuyCnt++;
    if (type == OP_SELL) SellCnt++;
    if (type == OP_BUYSTOP) BuyStopCnt++;
    if (type == OP_SELLSTOP) SellStopCnt++;
    if (type == OP_BUYLIMIT) BuyLimitCnt++;
    if (type == OP_SELLLIMIT) SellLimitCnt++;
  }
}

int OrdersCountBar0(int TF)
{
  int orders = 0;

  int cnt = OrdersTotal();
  for (int i=0; i<cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;

    if (OrderOpenTime() >= iTime(NULL, TF, 0)) orders++;
  }

  cnt = OrdersHistoryTotal();
  for (i=0; i<cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;

    if (OrderOpenTime() >= iTime(NULL, TF, 0)) orders++;
  }
 
  return (orders);
}

int CloseOrders(int type1, int type2 = -1) 
{  
  int cnt = OrdersTotal();
  for (int i=cnt-1; i >= 0; i--) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type = OrderType();
    if (type != type1 && type != type2) continue;
    
    if (type == OP_BUY) 
    {
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID));
      continue;
    }
    
    if (type == OP_SELL) 
    {
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK));
      continue;
    }    
  }
  
  int orders = 0;
  cnt = OrdersTotal();
  for (i = 0; i < cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    type = OrderType();
    if (type != type1 && type != type2) continue;
    
    orders++;
  }
  
  return (orders); 
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 500;
int SleepErr = 2000;

int Buy(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Buy \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  int res = OrderSend(symbol, OP_BUY, lot, price, Slippage, sl, tp, comment, magic, 0, clBuy);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int Sell(string symbol, double lot, double price, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Sell \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELL, lot, price, Slippage, sl, tp, comment, magic, 0, clSell);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening SELL order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price) 
{
  if (!OrderSelect(ticket, SELECT_BY_TICKET)) return(false);
  if (OrderCloseTime() > 0) return(false);
  
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", Slippage);
  
  bool res = OrderClose(ticket, lot, price, Slippage, clClose);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}